// ATLCalculator.h : Defines the ATL Server request handler class
//
#pragma once

namespace ATLCalculatorService
{
// all struct, enum, and typedefs for your webservice should go inside the namespace

// IATLCalculatorService - web service interface declaration
//
[
	uuid("11C95BE4-0BB7-442E-A978-D1B93C0A6309"), 
	object
]
__interface IATLCalculatorService
{
	// HelloWorld is a sample ATL Server web service method.  It shows how to
	// declare a web service method and its in-parameters and out-parameters
	[id(1)] HRESULT HelloWorld([in] BSTR bstrInput, [out, retval] BSTR *bstrOutput);
	// TODO: Add additional web service methods here
    [helpstring("method Add")] HRESULT Add([in] DOUBLE x, [in] DOUBLE y, [out,retval] DOUBLE* pResult);
};


// ATLCalculatorService - web service implementation
//
[
	request_handler(name="Default", sdl="GenATLCalculatorWSDL"),
	soap_handler(
		name="ATLCalculatorService", 
		namespace="urn:ATLCalculatorService",
		protocol="soap"
	)
]
class CATLCalculatorService :
	public IATLCalculatorService
{
public:
	// This is a sample web service method that shows how to use the 
	// soap_method attribute to expose a method as a web method
	[ soap_method ]
	HRESULT HelloWorld(/*[in]*/ BSTR bstrInput, /*[out, retval]*/ BSTR *bstrOutput)
	{
		CComBSTR bstrOut(L"Hello ");
		bstrOut += bstrInput;
		bstrOut += L"!";
		*bstrOutput = bstrOut.Detach();
		
		return S_OK;
	}

	[ soap_method ]
    HRESULT Add(/*[in]*/ DOUBLE x, /*[in]*/ DOUBLE y,/* [out,retval]*/ DOUBLE* pResult)
    {
        *pResult = x + y;
		return S_OK;
    }
}; // class CATLCalculatorService

} // namespace ATLCalculatorService
