// ADOEmployeeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ADOEmployee.h"
#include "ADOEmployeeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CADOEmployeeDlg dialog



CADOEmployeeDlg::CADOEmployeeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CADOEmployeeDlg::IDD, pParent)
    , m_Name(_T(""))
    , m_Dept(_T(""))
    , m_ID(_T(""))
    , m_Rate(0)
    , m_Lookup(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CADOEmployeeDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_NAME, m_Name);
    DDX_Text(pDX, IDC_DEPT, m_Dept);
    DDX_Text(pDX, IDC_ID, m_ID);
    DDX_Text(pDX, IDC_RATE, m_Rate);
    DDX_Text(pDX, IDC_LOOKUP_NAME, m_Lookup);
}

BEGIN_MESSAGE_MAP(CADOEmployeeDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
    ON_BN_CLICKED(ID_LOOKUP, OnBnClickedLookup)
END_MESSAGE_MAP()


// CADOEmployeeDlg message handlers

BOOL CADOEmployeeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CADOEmployeeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CADOEmployeeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CADOEmployeeDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CADOEmployeeDlg::OnBnClickedLookup()
{
   this->UpdateData();

   if (m_Lookup == "")
   {
      AfxMessageBox("Please enter a name to look up.", MB_OK, 0);
      return;
   }

   try 
   {
      _ConnectionPtr pConn = NULL;
      _RecordsetPtr pRS = NULL;
      _bstr_t sql;

      // create instances of the connection and recordset objects
      if (FAILED(pConn.CreateInstance(__uuidof(Connection)))) 
      {
         AfxMessageBox("Could not create instance of Connection", 
           MB_OK | MB_ICONEXCLAMATION, 0);
         return;
      }

      if (FAILED(pRS.CreateInstance(__uuidof(Recordset)))) 
      {
         AfxMessageBox("Could not create instance of Recordset", 
           MB_OK | MB_ICONEXCLAMATION, 0);
         return;
      }

      // open the connection to the database
      pConn->Open("Department Store", "", "", adConnectUnspecified);

      sql = "SELECT * FROM Employees WHERE EmployeeName LIKE '%" 
               + m_Lookup + "%'";

      // look up the name
      pRS->Open(sql, pConn->GetConnectionString(), 
           adOpenStatic, adLockReadOnly, adCmdText);

      if (!pRS->EndOfFile) 
      {
         m_ID = pRS->GetFields()->GetItem("EmployeeID")->GetValue();
         m_Name = pRS->GetFields()->GetItem("EmployeeName")->GetValue();
         m_Rate = pRS->GetFields()->GetItem("EmployeeRate")->GetValue();
         m_Dept = pRS->GetFields()->GetItem("DeptID")->GetValue();

         this->UpdateData(FALSE);
      }
      else
      {
         AfxMessageBox("Employee could not be found.", MB_OK, 0);
      }

      // close the connection
      pConn->Close();
   }
   catch (_com_error &e) {
      CString msg;
      msg = "Error Description = ";
      msg.Append(e.Description());
      AfxMessageBox(msg, MB_OK | MB_ICONEXCLAMATION, 0);
   }
}
