// EmployeeView.cpp : implementation of the CEmployeeView class
//

#include "stdafx.h"
#include "Employee.h"

#include "EmployeeSet.h"
#include "EmployeeDoc.h"
#include "EmployeeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "FilterDlg.h"

// CEmployeeView

IMPLEMENT_DYNCREATE(CEmployeeView, CRecordView)

BEGIN_MESSAGE_MAP(CEmployeeView, CRecordView)
    // Standard printing commands
    ON_COMMAND(ID_FILE_PRINT, CRecordView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_DIRECT, CRecordView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRecordView::OnFilePrintPreview)
    ON_COMMAND(ID_RECORD_DELETERECORD, OnRecordDeleterecord)
    ON_COMMAND(ID_RECORD_ADDRECORD, OnRecordAddrecord)
    ON_COMMAND(ID_SORT_DEPARTMENT, OnSortDepartment)
    ON_COMMAND(ID_SORT_ID, OnSortId)
    ON_COMMAND(ID_SORT_NAME, OnSortName)
    ON_COMMAND(ID_SORT_RATE, OnSortRate)
    ON_COMMAND(ID_FILTER_DEPARTMENT, OnFilterDepartment)
    ON_COMMAND(ID_FILTER_ID, OnFilterId)
    ON_COMMAND(ID_FILTER_NAME, OnFilterName)
    ON_COMMAND(ID_FILTER_RATE, OnFilterRate)
END_MESSAGE_MAP()

// CEmployeeView construction/destruction

CEmployeeView::CEmployeeView()
: CRecordView(CEmployeeView::IDD)
{
    m_pSet = NULL;
    m_bAdding = FALSE;
}

CEmployeeView::~CEmployeeView()
{
}

void CEmployeeView::DoDataExchange(CDataExchange* pDX)
{
    DDX_Text(pDX, IDC_EMPLOYEE_ID, m_pSet->m_EmployeeID);
    DDX_Text(pDX, IDC_EMPLOYEE_NAME, m_pSet->m_EmployeeName);
    DDX_Text(pDX, IDC_EMPLOYEE_RATE, m_pSet->m_EmployeeRate);
    DDX_Text(pDX, IDC_EMPLOYEE_DEPT, m_pSet->m_DeptID);
    CRecordView::DoDataExchange(pDX);
    // you can insert DDX_Field* functions here to 'connect' your controls to the database fields, ex.
    // DDX_FieldText(pDX, IDC_MYEDITBOX, m_pSet->m_szColumn1, m_pSet);
    // DDX_FieldCheck(pDX, IDC_MYCHECKBOX, m_pSet->m_bColumn2, m_pSet);
    // See MSDN and ODBC samples for more information
}

BOOL CEmployeeView::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO: Modify the Window class or styles here by modifying
    //  the CREATESTRUCT cs

    return CRecordView::PreCreateWindow(cs);
}

void CEmployeeView::OnInitialUpdate()
{
    m_pSet = &GetDocument()->m_EmployeeSet;
    CRecordView::OnInitialUpdate();
}


// CEmployeeView printing

BOOL CEmployeeView::OnPreparePrinting(CPrintInfo* pInfo)
{
    // default preparation
    return DoPreparePrinting(pInfo);
}

void CEmployeeView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO: add extra initialization before printing
}

void CEmployeeView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO: add cleanup after printing
}


// CEmployeeView diagnostics

#ifdef _DEBUG
void CEmployeeView::AssertValid() const
{
    CRecordView::AssertValid();
}

void CEmployeeView::Dump(CDumpContext& dc) const
{
    CRecordView::Dump(dc);
}

CEmployeeDoc* CEmployeeView::GetDocument() const // non-debug version is inline
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEmployeeDoc)));
    return (CEmployeeDoc*)m_pDocument;
}
#endif //_DEBUG


// CEmployeeView database support
CRecordset* CEmployeeView::OnGetRecordset()
{
    return m_pSet;
}



// CEmployeeView message handlers

void CEmployeeView::OnRecordAddrecord()
{
    m_pSet->AddNew();
    m_pSet->m_EmployeeRate = 0.0f;
    m_pSet->m_EmployeeID = 0;
    m_bAdding = TRUE;
    CEdit* pCtrl = (CEdit*)GetDlgItem(IDC_EMPLOYEE_ID);
    int result = pCtrl->SetReadOnly(FALSE);
    UpdateData(FALSE);
}

void CEmployeeView::OnRecordDeleterecord()
{
    m_pSet->Delete();
    m_pSet->MoveNext();

    if (m_pSet->IsEOF())
        m_pSet->MoveLast();
    if (m_pSet->IsBOF())
        m_pSet->SetFieldNull(NULL);

    UpdateData(FALSE);
}


BOOL CEmployeeView::OnMove(UINT nIDMoveCommand)
{
    if (m_bAdding)
    {
        m_bAdding = FALSE;
        UpdateData(TRUE);
        if (m_pSet->CanUpdate())
            m_pSet->Update();
        m_pSet->Requery();
        UpdateData(FALSE);
        CEdit* pCtrl = (CEdit*)GetDlgItem(IDC_EMPLOYEE_ID);
        pCtrl->SetReadOnly(TRUE);
        return TRUE;
    }
    else
        return CRecordView::OnMove(nIDMoveCommand);
}

void CEmployeeView::OnSortDepartment()
{
    m_pSet->Close();
    m_pSet->m_strSort = "DeptID";
    m_pSet->Open();
    UpdateData(FALSE);
}

void CEmployeeView::OnSortId()
{
    m_pSet->Close();
    m_pSet->m_strSort = "EmployeeID";
    m_pSet->Open();
    UpdateData(FALSE);
}

void CEmployeeView::OnSortName()
{
    m_pSet->Close();
    m_pSet->m_strSort = "EmployeeName";
    m_pSet->Open();
    UpdateData(FALSE);
}

void CEmployeeView::OnSortRate()
{
    m_pSet->Close();
    m_pSet->m_strSort = "EmployeeRate";
    m_pSet->Open();
    UpdateData(FALSE);
}

void CEmployeeView::OnFilterDepartment()
{
    DoFilter("DeptID");}

void CEmployeeView::OnFilterId()
{
    DoFilter("EmployeeID");}

void CEmployeeView::OnFilterName()
{
    DoFilter("EmployeeName");}

void CEmployeeView::OnFilterRate()
{
    DoFilter("EmployeeRate");}

void CEmployeeView::DoFilter(CString col)
{
    CFilterDlg dlg;
    int result = dlg.DoModal();

    if (result == IDOK)
    {
        CString str;
        if ((col == "EmployeeRate") || (col == "EmployeeID"))
            str = col + " = " + dlg.m_filterValue;
        else
            str = col + " = '" + dlg.m_filterValue + "'";

        m_pSet->Close();
        m_pSet->m_strFilter = str;
        m_pSet->Open();
        int recCount = m_pSet->GetRecordCount();

        if (recCount == 0)
        {
            MessageBox("No matching records.");
            m_pSet->Close();
            m_pSet->m_strFilter = "";
            m_pSet->Open();
        }

        UpdateData(FALSE);
    }
}