using System;

namespace CanadaCodeCheck
{
    /// <summary>
    /// CanadaCodeChecker validates that a string is 
    /// a valid Canadian postal code such as M5W 1E4
    /// </summary>
    public class CanadaCodeChecker : PostCodeCheck.PostCodeChecker
    {
        public CanadaCodeChecker()
        {
            //
            // TODO: Add constructor logic here
            //
        }
        public override string Check(String code)
        {
            string error = "OK";
            if (code.Length != 7)
            {
                error = "Invalid length";
                return error;
            }
            for (int i = 0; i < code.Length; i++)
            {
                if (i == 0 || i == 2 || i == 5)
                {
                    if (!Char.IsLetter(
                        Convert.ToChar(code.Substring(i, 1))))
                    {
                        error = "Character " + i + " must be a letter";
                    }
                }
                if (i == 1 || i == 4 || i == 6)
                {
                    if (!Char.IsDigit(
                        Convert.ToChar(code.Substring(i, 1))))
                    {
                        error = "Character " + i + " must be a numeric digit";
                    }
                }
                if (i == 3)
                {
                    if (code.Substring(i, 1) != " ")
                    {
                        error = "Character 3 must be a space";
                    }
                }
            }
            return error;
        }

    }
}
