// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

#using <mscorlib.dll>
#include <tchar.h>

#using <mscorlib.dll>
#using <System.dll>
#using <System.Data.dll>
#using <System.Xml.dll>

using namespace System;
using namespace System::Data;
using namespace System::Data::OleDb;
using namespace System::Xml;
using namespace System::IO;

// This is the entry point for this application
int _tmain(void)
{
    DataSet* deptStore = new DataSet("DepartmentStore");
    OleDbConnection* conn;
    FileStream* xmlFile;
    try 
    {
        xmlFile = new FileStream("db.xml",
            FileMode::Open,
            FileAccess::Read);

        XmlTextReader* reader = new XmlTextReader(xmlFile);
        deptStore->ReadXml(reader, XmlReadMode::InferSchema);

        // write the loaded data to the database
        String* connectionstring = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=deptstore.mdb;";
        conn = new OleDbConnection(connectionstring);
        conn->Open();

        OleDbDataAdapter* adapter = new OleDbDataAdapter();    
        adapter->SelectCommand = new OleDbCommand("SELECT * FROM Employees", conn);
        OleDbCommandBuilder* CB = new OleDbCommandBuilder(adapter);
        adapter->Update(deptStore, "Employees");

        Console::WriteLine("The database was filled successfully.");
    }
    catch(IOException* ioe) 
    {
        Console::WriteLine("Could not open XML file.");
        Console::WriteLine(ioe->get_Message());
    }
    catch(Exception*  e) 
    {
        Console::WriteLine("The database could not be filled.");
        Console::WriteLine(e->get_Message());
    }
    conn->Close();
    Console::ReadLine();
    return 0;
}