// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

#using <mscorlib.dll>
#include <tchar.h>

#using <System.dll>
#using <System.data.dll>
#using <System.Xml.dll>

using namespace System;
using namespace System::Data;
using namespace System::Data::OleDb;

// This is the entry point for this application
int _tmain(void)
{
    OleDbConnection* conn;
    DataSet* deptStore = new DataSet("DepartmentStore");
    DataTable* depts = new DataTable("Departments");

    DataTable* employees = new DataTable("Employees");

    DataTable* managers = new DataTable("DeptManagers");
    try
    {
        String* connectionstring = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=deptstore.mdb;";
        conn = new OleDbConnection(connectionstring);
        conn->Open();
        String* query;
        OleDbDataAdapter* adapter = new OleDbDataAdapter();

        query = "SELECT * FROM Departments";
        adapter->SelectCommand = new OleDbCommand(query, conn);
        adapter->Fill(depts);
        deptStore->get_Tables()->Add(depts);

        query = "SELECT * FROM Employees";
        adapter->SelectCommand = new OleDbCommand(query, conn);
        adapter->Fill(employees);
        deptStore->get_Tables()->Add(employees);

        DataColumn* keys __gc[] = new DataColumn* __gc[1];
        keys[0] = employees->get_Columns()->get_Item("EmployeeID");
        employees->set_PrimaryKey(keys);


        query = "SELECT * FROM DeptManagers";
        adapter->SelectCommand = new OleDbCommand(query, conn);
        adapter->Fill(managers);
        deptStore->get_Tables()->Add(managers);

        DataRelation* mngr_dept = new DataRelation("Manager_To_Dept",
            managers->get_Columns()->get_Item("DeptID"),
            depts->get_Columns()->get_Item("DeptID"));
        deptStore->get_Relations()->Add(mngr_dept);

        DataRelation* dept_emp = new DataRelation("Dept_to_Employee",
            depts->get_Columns()->get_Item("DeptID"),
            employees->get_Columns()->get_Item("DeptID"));
        deptStore->get_Relations()->Add(dept_emp);

        DataRelation* emp_mngr = new DataRelation("Employee to Manager",
            employees->get_Columns()->get_Item("EmployeeID"),
            managers->get_Columns()->get_Item("ManagerID"));
        deptStore->get_Relations()->Add(emp_mngr);

    }
    catch(OleDbException* e)
    {
        Console::WriteLine("OleDbException caught");
        Console::WriteLine(e->get_Message());
    }
    conn->Close();
    int empCount = employees->get_Rows()->get_Count();

    Console::WriteLine("Find a Manager");
    Console::WriteLine("");
    Console::WriteLine("Employees:");
    for (int i = 0; i < empCount; i++)
    {
        Console::Write(employees->get_Rows()->get_Item(i)->get_Item("EmployeeID"));
        Console::Write(" ");
        Console::Write(employees->get_Rows()->get_Item(i)->get_Item("EmployeeName"));
        Console::WriteLine("");
    }

    int empNum;
    try
    {
        Console::Write("Enter the number of an employee: ");
        empNum = Convert::ToInt32(Console::ReadLine());
        if (empNum < 0 ) throw new FormatException();
    }
    catch(FormatException*) 
    {
        Console::WriteLine("Invalid choice");
    }

    DataRow* emp = employees->get_Rows()->Find(__box(empNum));
    DataRow* mgr = emp->GetParentRow("Dept_to_Employee")->
        GetParentRow("Manager_to_Dept")->
        GetParentRow("Employee to Manager");

    Console::WriteLine("");
    Console::Write("The manager for ");
    Console::Write(emp->get_Item("EmployeeName"));
    Console::Write(" is:  ");
    Console::Write(mgr->get_Item("EmployeeName"));
    Console::WriteLine("");

    Console::ReadLine();
    return 0;
}