// ScrollerView.cpp : implementation of the CScrollerView class
//

#include "stdafx.h"
#include "Scroller.h"

#include "ScrollerDoc.h"
#include "ScrollerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CScrollerView

IMPLEMENT_DYNCREATE(CScrollerView, CScrollView)

BEGIN_MESSAGE_MAP(CScrollerView, CScrollView)
    // Standard printing commands
    ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
    ON_WM_LBUTTONDOWN()
    ON_WM_RBUTTONDOWN()
END_MESSAGE_MAP()

// CScrollerView construction/destruction

CScrollerView::CScrollerView()
{
    // TODO: add construction code here

}

CScrollerView::~CScrollerView()
{
}

BOOL CScrollerView::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO: Modify the Window class or styles here by modifying
    //  the CREATESTRUCT cs

    return CScrollView::PreCreateWindow(cs);
}

// CScrollerView drawing

void CScrollerView::OnDraw(CDC* pDC)
{
    CScrollerDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    // get the number of lines from the document
    int numLines = pDoc->m_NumLines;

    // Initialize a LOGFONT structure for the fonts.
    LOGFONT logFont;
    logFont.lfHeight = 24;
    logFont.lfWidth = 0;
    logFont.lfEscapement = 0;
    logFont.lfOrientation = 0;
    logFont.lfWeight = FW_NORMAL;
    logFont.lfItalic = 0;
    logFont.lfUnderline = 0;
    logFont.lfStrikeOut = 0;
    logFont.lfCharSet = ANSI_CHARSET;
    logFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
    logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    logFont.lfQuality = PROOF_QUALITY;
    logFont.lfPitchAndFamily = VARIABLE_PITCH | FF_ROMAN;
    strcpy(logFont.lfFaceName, "Times New Roman");

    // Create a new font and select it into the DC.
    CFont* font = new CFont();
    font->CreateFontIndirect(&logFont);
    CFont* oldFont = pDC->SelectObject(font);

    // Initialize the position of text in the window.
    int position = 0;

    // Create and display eight example lines.
    for (int x=0; x<numLines; ++x)
    {
        // Create the string to display.
        char s[25];
        wsprintf(s, "This is line #%d", x+1);

        // Print text with the new font.
        pDC->TextOut(20, position, s);
        position += logFont.lfHeight;
    }
    // Calculate the document size.
    CSize docSize(100, numLines*logFont.lfHeight);

    // Calculate the page size.
    CRect rect;
    GetClientRect(&rect);
    CSize pageSize(rect.right, rect.bottom);

    // Calculate the line size.
    CSize lineSize(0, logFont.lfHeight);

    // Adjust the scrollers.
    SetScrollSizes(MM_TEXT, docSize, pageSize, lineSize);

    // Restore the old font to the DC, and
    // delete the font the program created.
    pDC->SelectObject(oldFont);
    delete font;
}

void CScrollerView::OnInitialUpdate()
{
    CScrollView::OnInitialUpdate();
    CSize sizeTotal;
    // TODO: calculate the total size of this view
    sizeTotal.cx = sizeTotal.cy = 100;
    SetScrollSizes(MM_TEXT, sizeTotal);
}


// CScrollerView printing

BOOL CScrollerView::OnPreparePrinting(CPrintInfo* pInfo)
{
    // default preparation
    return DoPreparePrinting(pInfo);
}

void CScrollerView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO: add extra initialization before printing
}

void CScrollerView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO: add cleanup after printing
}


// CScrollerView diagnostics

#ifdef _DEBUG
void CScrollerView::AssertValid() const
{
    CScrollView::AssertValid();
}

void CScrollerView::Dump(CDumpContext& dc) const
{
    CScrollView::Dump(dc);
}

CScrollerDoc* CScrollerView::GetDocument() const // non-debug version is inline
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CScrollerDoc)));
    return (CScrollerDoc*)m_pDocument;
}
#endif //_DEBUG


// CScrollerView message handlers

void CScrollerView::OnLButtonDown(UINT nFlags, CPoint point)
{
    CScrollerDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    // Increase number of lines to display.
    pDoc->m_NumLines += 5;

    // Redraw the window.
    Invalidate();

    CScrollView::OnLButtonDown(nFlags, point);
}

void CScrollerView::OnRButtonDown(UINT nFlags, CPoint point)
{
    CScrollerDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    // Decrease number of lines to display.
    pDoc->m_NumLines -= 5;

    if (pDoc->m_NumLines < 0)
    {
        pDoc->m_NumLines = 0;
    }

    // Redraw the window.
    Invalidate();

    CScrollView::OnRButtonDown(nFlags, point);
}
