// CommonView.h : interface of the CCommonView class
//


#pragma once


class CCommonView : public CScrollView
{
protected: // create from serialization only
	CCommonView();
	DECLARE_DYNCREATE(CCommonView)

// Attributes
public:
	CCommonDoc* GetDocument() const;
protected:
   //Progress Bar
    CProgressCtrl m_progressBar;

   //Trackbar or Slider
    CSliderCtrl m_trackbar;
    BOOL m_timer;

   // Up-Down or Spinner
    CSpinButtonCtrl m_upDown;
    CEdit m_buddyEdit;

   // List View
    CListCtrl m_listView;
    CImageList m_smallImageList;
    CImageList m_largeImageList;
    CButton m_smallButton;
    CButton m_largeButton;
    CButton m_listButton;
    CButton m_reportButton;

   // Tree View
    CTreeCtrl m_treeView;
    CImageList m_treeImageList;

   // Rich Edit
    CRichEditCtrl m_richEdit;
    CButton m_boldButton;
    CButton m_leftButton;
    CButton m_centerButton;
    CButton m_rightButton;
   // IP Address
   CIPAddressCtrl m_ipaddress;
   // Date Picker
   CDateTimeCtrl m_date;
   // Month Calendar
   CMonthCalCtrl m_month;

// Operations
public:

// Overrides
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CCommonView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
    afx_msg void OnSmall();
    afx_msg void OnLarge();
    afx_msg void OnList();
    afx_msg void OnReport();
    afx_msg void OnULine();
    afx_msg void OnLeft();
    afx_msg void OnCenter();
    afx_msg void OnRight();
public:
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    void CreateProgressBar(void);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnDestroy();
    afx_msg void OnTimer(UINT nIDEvent);
    void CreateTrackBar(void);
    afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
    void CreateUpDownCtrl(void);
    void CreateListView(void);
    void CreateTreeView(void);
protected:
    virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
public:
    void CreateRichEdit(void);
    void CreateIPAddress(void);
    void CreateDatePicker(void);
    void CreateMonth(void);
};

#ifndef _DEBUG  // debug version in CommonView.cpp
inline CCommonDoc* CCommonView::GetDocument() const
   { return reinterpret_cast<CCommonDoc*>(m_pDocument); }
#endif

