// OptionsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "ShowString.h"
#include "OptionsDialog.h"
#include <htmlhelp.h>

// COptionsDialog dialog

static DWORD aHelpIDs[] =
{
    IDC_OPTIONS_STRING, HIDD_OPTIONS_STRING,
    IDC_OPTIONS_BLACK, HIDD_OPTIONS_BLACK,
    IDC_OPTIONS_RED, HIDD_OPTIONS_RED,
    IDC_OPTIONS_GREEN, HIDD_OPTIONS_GREEN,
    IDC_OPTIONS_HORIZCENTER, HIDD_OPTIONS_HORIZCENTER,
    IDC_OPTIONS_VERTCENTER, HIDD_OPTIONS_VERTCENTER,
    IDOK, HIDD_OPTIONS_OK,
    IDCANCEL, HIDD_OPTIONS_CANCEL,
    0, 0
};


IMPLEMENT_DYNAMIC(COptionsDialog, CDialog)
COptionsDialog::COptionsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDialog::IDD, pParent)
    , m_string(_T(""))
    , m_color(0)
    , m_horizcenter(FALSE)
    , m_vertcenter(FALSE)
{
}

COptionsDialog::~COptionsDialog()
{
}

void COptionsDialog::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_OPTIONS_STRING, m_string);
    DDX_Radio(pDX, IDC_OPTIONS_BLACK, m_color);
    DDX_Check(pDX, IDC_OPTIONS_HORIZCENTER, m_horizcenter);
    DDX_Check(pDX, IDC_OPTIONS_VERTCENTER, m_vertcenter);
}


BEGIN_MESSAGE_MAP(COptionsDialog, CDialog)
    ON_WM_CONTEXTMENU()
    ON_WM_HELPINFO()
END_MESSAGE_MAP()


// COptionsDialog message handlers


void COptionsDialog::OnContextMenu(CWnd* pWnd, CPoint /*point*/)
{
	CString filename = AfxGetApp()->m_pszHelpFilePath;
	filename += "::/ctrlhlp.txt";		// the file that contains the
						// pop-up text

	::HtmlHelp(
	pWnd->GetSafeHwnd(),
		filename,
		HH_TP_HELP_CONTEXTMENU,
		(DWORD_PTR)aHelpIDs);
}

BOOL COptionsDialog::OnHelpInfo(HELPINFO* pHelpInfo)
{
    if (pHelpInfo->iContextType == HELPINFO_WINDOW) // must be for a control
    {
	    CString filename = AfxGetApp()->m_pszHelpFilePath;
	    filename += "::/ctrlhlp.txt";		// the file that contains the
						    // pop-up text

	    return ::HtmlHelp(
			    (HWND)pHelpInfo->hItemHandle,
			    filename,
			    HH_TP_HELP_WM_HELP,
			    (DWORD_PTR)aHelpIDs) != NULL;
    }
    return TRUE;
}
